<template>
    <div class="card shadow mb-4">
        <form @submit.prevent="onSubmit()">
            <div
                class="card-header bg-white py-3 d-flex flex-row align-items-center justify-content-between"
            >
                <h6 class="m-0 font-weight-bold text-primary text-capitalize">
                    {{ dataObject.name }}
                </h6>
                <a @click="onExit" type="button"
                    ><i class="fa fa-times" aria-hidden="true"></i
                ></a>
            </div>
            <div class="card-body px-5">
                <div class="row align-items-center">
                    <div class="col-12 col-md-4">
                        <div class="row">
                            <div class="col-12 text-center">
                                <img
                                    :src="dataObject.image_path"
                                    class="img-thumbnail"
                                    width="200px"
                                    height="200px"
                                />
                                <div class="d-flex justify-content-center mt-3">
                                    <label class="btn btn-primary btn-sm m-1">
                                        Browse
                                        <input
                                            type="file"
                                            accept="image/*"
                                            @change="onImageChange"
                                            ref="fileInput"
                                            hidden
                                        />
                                    </label>
                                    <button
                                        type="button"
                                        class="btn btn-secondary btn-sm m-1"
                                        @click="onImageReset"
                                    >
                                        Reset
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-12 col-md-8">
                        <div class="row align-items-end">
                            <div class="col-12">
                                <div class="text-xs text-uppercase mb-1">
                                    Item Name
                                </div>
                                <input
                                    type="text"
                                    v-model="dataObject.name"
                                    class="form-control mr-5"
                                    placeholder="Item Name"
                                    ref="name"
                                    tabindex="1"
                                />
                            </div>
                            <div class="col-12 col-md-6">
                                <div class="text-xs text-uppercase mb-1">
                                    Description
                                </div>
                                <input
                                    type="text"
                                    v-model="dataObject.description"
                                    class="form-control"
                                    placeholder="Description"
                                    tabindex="2"
                                />
                            </div>
                            <div class="col-12 col-md-3">
                                <div class="text-xs text-uppercase mb-1">
                                    Price Rate
                                </div>
                                <input
                                    type="text"
                                    v-model="dataObject.price_rate"
                                    class="form-control"
                                    placeholder="Price Rate"
                                    tabindex="3"
                                />
                            </div>
                            <div class="col-12 col-md-3">
                                <div class="text-xs text-uppercase mb-1">
                                    Amount
                                </div>
                                <input
                                    type="text"
                                    v-model="dataObject.amount"
                                    class="form-control"
                                    placeholder="Amount"
                                    tabindex="3"
                                />
                            </div>
                            <div class="col-12 col-md-6">
                                <div class="text-xs text-uppercase mb-1">
                                    Related Items
                                </div>
                                <multi-select
                                    v-model="dataObject.items"
                                    :options="dataItems"
                                    :multiple="true"
                                    track-by="id"
                                    label="name"
                                    placeholder="Select Related Items"
                                >
                                </multi-select>
                            </div>
                            <div class="col-12 col-md-4">
                                <div class="text-xs text-uppercase mb-1">
                                    Tags
                                </div>
                                <multi-select
                                    v-model="dataObject.tags"
                                    label="name"
                                    track-by="name"
                                    :options="dataTags"
                                    :multiple="true"
                                    :taggable="true"
                                    tag-placeholder="Add this as new tag"
                                    placeholder="Search or add a tag"
                                    @tag="addTag"
                                >
                                </multi-select>
                            </div>
                            <div class="col-12 col-md-2 ml-auto">
                                <input
                                    type="submit"
                                    class="btn btn-primary btn-block"
                                    tabindex="4"
                                    :value="
                                        isAction('create') ? 'Save' : 'Update'
                                    "
                                    :disabled="isDisabledButton"
                                />
                            </div>
                        </div>
                    </div>
                </div>
                <div class="text-xs text-uppercase mb-1">
                    Attributes (optional)
                </div>
                <div
                    v-for="(meta, index) in dataObject.metas"
                    :key="index"
                    class="row align-items-center"
                >
                    <div class="col-6">
                        <input
                            type="text"
                            v-model="meta.key"
                            class="form-control"
                            placeholder="Meta Key"
                            @change="onMetaChange"
                        />
                    </div>
                    <div class="col-6">
                        <input
                            type="text"
                            v-model="meta.value"
                            class="form-control"
                            placeholder="Meta Value"
                            @change="onMetaChange"
                        />
                    </div>
                </div>
            </div>
            <div class="card-footer text-center">
                <div class="collapse" :id="'collapseTarget' + _uid">
                    <item-card
                        v-for="item in this.dataObject.items"
                        :key="item.id"
                        :object="item"
                        :disabled="true"
                    >
                    </item-card>
                </div>
                <a
                    data-toggle="collapse"
                    :data-target="'#collapseTarget' + _uid"
                    class="text-dark"
                >
                    <div>
                        <i class="fa fa-bars" aria-hidden="true"></i>
                    </div>
                </a>
            </div>
        </form>
    </div>
</template>

<script>
import Swal from "sweetalert2";
import MultiSelect from "vue-multiselect";
import ItemCard from "./ItemCardComponent";
export default {
    components: {
        MultiSelect,
        ItemCard
    },
    props: [],
    data() {
        return {
            dataObject: {
                name: "",
                description: "",
                price_rate: 0,
                amount: 0,
                metas: [],
                items: [],
                tags: [],
                image: "",
                image_path: "/img/no_image.jpg"
            },
            isDisabledButton: false,
            dataAction: "create",
            dataItems: [],
            dataTags: [],
            reset_image: false,
            isChanges: false,
            unwatch: {}
        };
    },
    created() {
        this.prepare();
        this.debounce = _.debounce(this.chainUnwatch, 10000);
    },
    mounted() {
        this.$refs.name.focus();
        this.debounce();
    },
    methods: {
        addTag(newTag) {
            const tag = {
                name: newTag,
                // code:
                //     newTag.substring(0, 2) +
                //     Math.floor(Math.random() * 10000000)
            };
            this.dataTags.push(tag);
            this.dataObject.tags.push(tag);
        },
        chainUnwatch() {
            //dynamic watch use only once and destroy itself
            this.unwatch = this.$watch(
                "dataObject",
                function(oldValue, newValue) {
                    if (newValue) {
                        this.isChanges = true;
                        this.unwatch();
                    }
                },
                { deep: true }
            );
        },
        async prepare() {
            this.getTags();
            await this.getItems();

            if (this.$route.params.id) {
                this.dataAction = "edit";
                this.getObject();
            } else {
                this.onMetaChange();
            }
        },
        getObject() {
            return axios
                .get("/api/item/get/" + this.$route.params.id)
                .then(res => {
                    this.dataObject = res.data;

                    if (this.dataObject.image_path) {
                        this.dataObject.image_path =
                            "/storage/items/" + this.dataObject.image_path;
                    } else {
                        this.dataObject.image_path = "/img/no_image.jpg";
                    }

                    this.dataItems = this.filterDataItems(this.dataItems);
                    this.onMetaChange();
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        getTags() {
            return axios
                .get("/api/tag/all")
                .then(res => {
                    this.dataTags = res.data;
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        getItems() {
            return axios
                .get("/api/item/all")
                .then(res => {
                    this.dataItems = res.data;
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        filterDataItems(dataItems) {
            _.remove(dataItems, obj => {
                return obj.id == this.dataObject.id;
            });
            return _.reject(dataItems, obj => {
                return this.isItemRelated(obj, this.dataObject.id);
            });
        },
        isItemRelated(obj, relatedId) {
            return _.some(obj.items, o => {
                if (o.items.length) {
                    if (o.id == relatedId) {
                        return true;
                    }
                    return this.isItemRelated(o, relatedId);
                } else {
                    return o.id == relatedId;
                }
            });
        },
        onSubmit() {
            if (this.isDisabledButton) {
                return;
            }

            this.isDisabledButton = true;

            let formData = new FormData();

            formData.append("name", this.dataObject.name ?? "");
            formData.append("description", this.dataObject.description ?? "");
            formData.append("price_rate", this.dataObject.price_rate ?? 0);
            formData.append("amount", this.dataObject.amount ?? 0);
            formData.append("image", this.dataObject.image ?? "");
            formData.append("reset_image", this.reset_image ?? false);

            let tags = JSON.stringify(this.dataObject.tags);
            formData.append("tags", tags);

            let dataTags = JSON.stringify(this.dataTags);
            formData.append("dataTags", dataTags);

            let items = JSON.stringify(this.dataObject.items);
            formData.append("items", items);

            let metas = JSON.stringify(this.dataObject.metas);
            formData.append("metas", metas);

            if (this.isAction("create")) {
                axios
                    .post("/item", formData)
                    .then(res => {
                        Swal.fire("Created!", "", "success").then(result => {
                            this.$router.go(-1);
                        });
                    })
                    .catch(err => {
                        console.warn(err.response);
                        Swal.fire(
                            "Error!",
                            err.response.data.errors.name[0],
                            "error"
                        );
                    })
                    .then(res => {
                        this.isDisabledButton = false;
                    });
            } else if (this.isAction("edit")) {
                formData.append("_method", "patch");

                axios
                    .post("/item/" + this.dataObject.id, formData)
                    .then(res => {
                        Swal.fire("Updated!", "", "success").then(result => {
                            this.$router.go(-1);
                        });
                    })
                    .catch(err => {
                        console.warn(err.response);
                        Swal.fire(
                            "Error!",
                            err.response.data.errors.name[0],
                            "error"
                        );
                    })
                    .then(res => {
                        this.isDisabledButton = false;
                    });
            }
        },
        isAction(value) {
            return this.dataAction == value;
        },
        onMetaChange() {
            _.remove(this.dataObject.metas, obj => {
                return obj.key == "" && obj.value == "";
            });

            this.dataObject.metas.push({
                key: "",
                value: ""
            });
        },
        onImageChange(e) {
            let files = e.target.files || e.dataTransfer.files;
            if (files.length) {
                this.reset_image = false;
                this.dataObject.image = files[0];
                this.createImage(files[0]);
            }
        },
        onImageReset() {
            this.reset_image = true;
            this.dataObject.image = null;
            this.$refs.fileInput.value=null;
            this.dataObject.image_path = "/img/no_image.jpg";
        },
        createImage(file) {
            let reader = new FileReader();
            reader.onload = e => {
                this.dataObject.image_path = e.target.result;
            };
            reader.readAsDataURL(file);
        },
        onExit() {
            if (this.isChanges) {
                Swal.fire({
                    title: "Do you want to exit?",
                    icon: "warning",
                    showCancelButton: true
                }).then(result => {
                    if (result.isConfirmed) {
                        this.$router.go(-1);
                    }
                });
            } else {
                this.$router.go(-1);
            }
        }
    },
    computed: {}
};
</script>
